# -*- coding: utf-8 -*-
'''
   Arquivo: ordena1_selecao.py
   
   Dados um inteiro positivo n e uma sequência de n números inteiros,
   ordená-los crescentemente e imprimi-los. Para isso, usar uma
   função que faz a ordenação. (Veja a exolicação depois do programa.)
   
   Este algoritmo NÃO É MUITO EFICIENTE: faz um número de comparacoes da ordem de n^2,
   independentemente de a sequência estar ordenada ou quase ordenada. 
   
   OBS: Ordenacao por inserção é melhor (ver outro programa) <===================

'''
import random

def main():
    # n = int(input("Digite o número de elementos da sequência: "))
    #
    # vamos gerar uma sequência de n números inteiros aleatórios entre 1 e 50:
    # seq = []
    # for i in range(n):
    #    seq.append(random.randint(1,50))
    #   
    # print("Sequencia aleatória que foi gerada:")
    # print("                 ", seq)

    #---------------------------------------------------------------------------
    ## Vamos considerar a sequencia seq abaixo (sem fazer leitura, ou gerar aleatoriamente):
    
    seq = [5, 20, 3, 2, 14, 1, 7, 9, 15, 4]

    n = 10 
    print("sequencia dada  =", seq)


    ordena_por_selecao(seq)   # chamada da funcao ordena_por_selecao()

    # Depois da chamada da funcao, a lista seq fica ordenada.
    
    print(seq)
    
#-------------------------------------------------------------------------

def ordena_por_selecao(lista):
    ''' (list) --> None 
       
    Recebe uma lista com todos os valores de mesmo tipo.
    Rearranja os elementos da lista em ordem crescente;
    ou seja, lista[0] <= lista[1] <= ...
    '''

    n  = len(lista)    # comprimento da lista  
    
    for i in range(0, n-1):       # para i variando de 0 a comp-2
        ind_menor = i             # supomos que o elemento da posicao i é o menor
                                  # e marcamos que sua posicao é ind_menor.
                                  # lista[ind_menor] corresponde ao menor elemento (por enquanto)
        # vamos verificar se da posicao i+1 em diante há um elemento menor.
        for j in range(i+1, n):
            if lista[j] < lista[ind_menor]:
                 ind_menor = j   # se na posicao j temos que lista[j]< lista[ind_menor]
                                 # marcamos que a posicao do menor elemento é j (por equanto).
                                 # Só quando terminar o laço do "for j",
                                 # teremos certeza de que ind_menor é a posicao
                                 # onde está um menor elemento da lista
                                 # (a partir da posicao i). 
        if ind_menor != i: ### se forem iguais, nao precisamos trocar o elemento lista[i]
                           ### com lista[ind_menor]
                           ### senão,permutamos de lugar os elementos das posições i e ind_menor
            lista[i], lista[ind_menor]  = lista[ind_menor], lista[i]
            
        # neste ponto, lista[0 ... i] está em ordem crescente
        print("i = %2d -- lista = %s" %(i, lista)) # apenas para teste
        
#-----------------------------------------------------------------------

main()
""" 
      ------------ Ideia do algoritmo ---------------------------
         
n = 10                

     lista = [34,  85,  30,  20,  69,  13,  39,  64,  72,  32 ]
              --------------------------*--------------------
               0    1    2    3    4    5    6    7    8    9     n-1 comparacoes
              i = 0                   
              ind_menor = i = 0  (por enquanto 34 é o menor elemento)
              ind_menor = 2    (porque 30 é menor do que 34)
              ind_menor = 3    (porque 20 é menor do que 30)
              ind_menor = 5    (porque 13 é menor do que 20)  Depois disso nao achamos nnenhum menor do que 13
                Agora, permutamos quem está na posicao i=0 com  quem está na posicao ind_menor=5
                13 (que estava na posicao 5) vai para a posicao 0, e 
                34 (que estava na posicao 0) vai para posicao 5.                                                     
                     
         Fazemos i = i+1 e repetimos o processo a partir da posicao i, que passa a ser 1. 
         O elemento 13 que está na posição 0 é menor de todos (fica na posição de índice 0)
         Repetimos o processo a partir da posição 1. 
 
    lista = [13,  85,  30,  20,  69,  34,  39,  64,  72,  32]
                  -----------*--------------------------------
              0    1    2    3    4    5    6    7    8    9      n-2 comparacoes
                   i   
                ind_menor = i = 1            
                ind_menor = 2 (porque 30 é menor do que 85)
                ind_menor = 3 (porque 20 é menor do que 30) 
                
                Agora, permutamos quem está na posiçao i com quem está na posicao ind_menor.
                (Ou seja, permutamos quem está na posiçao 1 com quem está na posição 3.)

                 
    lista = [13,  20,  30,  85,  69,  34,  39,  64,  72,  32]
                        -------------------------------------
              0    1    2    3    4    5    6    7    8    9      n-3 comparacoes
                        i                                                                   
            ind_menor = i = 2 --- nao precisamos fazer nenhuma permutacao
                                 (quem está na posição 2 é o menor elemento a partir dessa posição)


                 
    lista = [13,  20,  30,  85,  69,  34,  39,  64,  72,  32]
                            ---------------------------------
              0    1    2    3    4    5    6    7    8    9
                             i                                                                   
                 ind_menor = i = 3                              n-4 comparacoes 
                 ind_menor = 4 (porque 69 é menor que 85)
                 ind_menor = 34 (porque 34 é menor do que 69)
                 ind_menor =  9 (porque 32 é menor do que 34)
                 Permutamos quem está na posicao i com quem está na posicao ind_menor.


                E assim sucessivamente até que i fica com o valor n-2 (= comp-2)

            Note que a parte inicial vai ficando ordenada crescentemente.

"""
